SynthDef(\mpvt_test, { |inbus = 3|
	var input, velocity, freq, output;
	
	input = AudioIn.ar([ inbus, inbus + 1 ]);
	velocity = MPVelocity.ar(input, generation: 4);
	velocity = velocity * (MPSignalPower.ar(input) > 0.1);
	freq = 40 + (50 * velocity.abs);
	output = Saw.ar([ freq, freq * 1.5 ], velocity);
	
	Out.ar(0, output);
}).store;

Synth(\mpvt_test);



// scratch a looped sample in real-time

SynthDef(\mpvt_scratch, { |inbus = 3, bufnum = 0|
	var input, velocity, freq, ring_freq, output;
	
	input = AudioIn.ar([ inbus, inbus + 1 ]);
	velocity = MPVelocity.ar(input, generation: 4);
	
	// PlayBuf only likes kr-rate inputs
	output = PlayBuf.ar(1, bufnum, A2K.kr(velocity) * BufRateScale.kr(bufnum), loop: 1);
	
	// ring modulate based on position on record
	ring_freq = LinExp.ar(MPPosition.ar(input, generation: 4), 0, 60000, 40, 5000);
	output = output * SinOsc.ar(ring_freq, 0);
	
	// gate based on signal strength;
	// silences when record is stopped
	output = output * MPSignalPower.ar(input);
	
	Out.ar(0, output.dup);
}).store;

(
b = Buffer.read(s, "sounds/a11wlk01.wav");
Synth(\mpvt_scratch, [ \bufnum, b.bufnum ]);
)

